package org.dromara.payment.operator.service;

import org.dromara.payment.common.domain.BusAccounts;
import org.dromara.payment.merchant.domain.vo.BusMerchantAccountVo;
import org.dromara.payment.operator.domain.BusOperatorAccount;
import org.dromara.payment.operator.domain.vo.BusOperatorAccountVo;
import org.dromara.payment.operator.domain.bo.BusOperatorAccountBo;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;

import java.util.Collection;
import java.util.List;
import java.util.function.Function;

/**
 * 运营商资金账户Service接口
 *
 * @author LionLi
 * @date 2024-03-28
 */
public interface IBusOperatorAccountService {



    public List<BusOperatorAccountVo>  queryListFp(BusOperatorAccountBo bo, PageQuery pageQuery);

    /**
     * 查询运营商资金账户
     */
    BusOperatorAccountVo queryById(Long id);

    /**
     * 查询运营商资金账户列表
     */
    TableDataInfo<BusOperatorAccountVo> queryPageList(BusOperatorAccountBo bo, PageQuery pageQuery);

    /**
     * 查询运营商资金账户列表
     */
    List<BusOperatorAccountVo> queryList(BusOperatorAccountBo bo);

    /**
     * 新增运营商资金账户
     */
    Boolean insertByBo(BusOperatorAccountBo bo);

    /**
     * 修改运营商资金账户
     */
    Boolean updateByBo(BusOperatorAccountBo bo);

    /**
     * 校验并批量删除运营商资金账户信息
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);


    /**
     * 递增或递减账户余额
     * @author 张涛
     * @date 2021年9月7日
     * @param amount 变动金额（减为复数）
     * @return
     */
    public Integer updateBalanceByAccId(int accId,long amount);

    /**
     * 递增或递减冻结金额
     * @author 张涛
     * @date 2021年9月7日
     * @param amount 变动金额（减为复数）
     * @return
     */
    public Integer updateFrozenByAccId(int accId,long amount);

    /**
     * 查询运营商提现账户信息
     * @param id 资金账户id
     * @return
     */
    public BusOperatorAccountVo getCashoutAccount(Long id);

    /***
     * 创建运营商虚拟户
     * @param sydId
     * @param opId
     * @param opName
     * @param bankType
     * @return
     */
    Boolean createXnAccount(Long sydId, Long opId, String opName, String bankType);



    public Boolean creatXNnum(Long sydId, Long unitId, String gsmc, int roleType, int addRoleType, String bankType1, Function<BusAccounts,Boolean> saveFun, Function<String,String> existsFun);
}
